-----------------------------------------------------------
-- FPGA Training Board(B6101)
-- 7Segment Decode circuit Ver.2
-----------------------------------------------------------
-- File   : decode2_7seg_vhdl_top.vhd
-- Date   : 2007-08-09
-- Family : Cyclone
-- Device : EP1C3T144C8
--
-- Designed by TOYO-LINX Co.,Ltd. / yKikuchi
-----------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity decode2_7seg_vhdl_top is
	port(
		LED_A	:	out std_logic;
		LED_B	:	out std_logic;
		LED_C	:	out std_logic;
		LED_D	:	out std_logic;
		LED_E	:	out std_logic;
		LED_F	:	out std_logic;
		LED_G	:	out std_logic;
		LED_DP	:	out std_logic;
		SW5		:	in std_logic;
		SW6		:	in std_logic;
		SW7		:	in std_logic
	);
end decode2_7seg_vhdl_top;

architecture RTL of decode2_7seg_vhdl_top is

	signal number	:	std_logic_vector(2 downto 0);
	signal led_data	:	std_logic_vector(7 downto 0);

begin

	number(2) <= not SW7;
	number(1) <= not SW6;
	number(0) <= not SW5;

	process(number)
	begin
		case number is
			when "000" =>
				led_data <= "00111111";
			when "001" =>
				led_data <= "00000110";
			when "010" =>
				led_data <= "01011011";
			when "011" =>
				led_data <= "01001111";
			when "100" =>
				led_data <= "01100110";
			when "101" =>
				led_data <= "01101101";
			when "110" =>
				led_data <= "01111101";
			when "111" =>
				led_data <= "00000111";
			when others =>
				led_data <= "00000000";
		end case;
	end process;
	
	LED_A  <= led_data(0);
	LED_B  <= led_data(1);
	LED_C  <= led_data(2);
	LED_D  <= led_data(3);
	LED_E  <= led_data(4);
	LED_F  <= led_data(5);
	LED_G  <= led_data(6);
	LED_DP <= led_data(7);
	
end RTL;
