-----------------------------------------------------------
-- FPGA Training Board(B6101)
-- Delay Flip Flop with Clear circuit
-----------------------------------------------------------
-- File   : dff_clrn_vhdl_top.vhd
-- Date   : 2007-08-17
-- Family : Cyclone
-- Device : EP1C3T144C8
--
-- Designed by TOYO-LINX Co.,Ltd. / yKikuchi
-----------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity dff_clrn_vhdl_top is
	port(
		LED1	:	out std_logic;
		LED2	:	out std_logic;
		SW5		:	in std_logic;
		SW6		:	in std_logic;
		SW7		:	in std_logic
	);
end dff_clrn_vhdl_top;

architecture RTL of dff_clrn_vhdl_top is

	signal D	:	std_logic;
	signal CLK	:	std_logic;
	signal CLRN	:	std_logic;
	signal Q	:	std_logic;
	signal QN	:	std_logic;

begin

	D    <= SW5;
	CLK  <= SW6;
	CLRN <= SW7;

	process(CLK,CLRN)
	begin
		if(CLRN='0') then
			Q <= '0';
		elsif(CLK'event and CLK='1') then
			Q <= D;
		end if;
	end process;
	QN <= not Q;
	
	LED1  <= Q;
	LED2  <= QN;
	
end RTL;
