-----------------------------------------------------------
-- FPGA Training Board(B6101)
-- 4 Line Input to 2 Line Output Priority Encoder Circuit
-----------------------------------------------------------
-- File   : encode_4to2_vhdl_top.vhd
-- Date   : 2009-06-05
-- Family : Cyclone
-- Device : EP1C3T144C8
--
-- Designed by TOYO-LINX Co.,Ltd. / yKikuchi
-----------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity encode_4to2_vhdl_top is
	port(
		LED_1	:	out std_logic;
		LED_2	:	out std_logic;
		SW5		:	in std_logic;
		SW6		:	in std_logic;
		SW7		:	in std_logic
	);
end encode_4to2_vhdl_top;

architecture RTL of encode_4to2_vhdl_top is

	signal A1	:	std_logic;
	signal A2	:	std_logic;
	signal A3	:	std_logic;
	signal Y	:	std_logic_vector(1 downto 0);

begin

	A1 <= not SW5;
	A2 <= not SW6;
	A3 <= not SW7;

	process (A1,A2,A3)
	begin
		if(A3 = '1') then
			Y <= "11";
		elsif(A2 = '1') then
			Y <= "10";
		elsif(A1 = '1') then
			Y <= "01";
		else
			Y <= "00";
		end if;
	end process;

	LED_1 <= Y(0);
	LED_2 <= Y(1);
	
end RTL;
