-----------------------------------------------------------
-- FPGA Training Board(B6101)
-- 7Segment LED Controller
-----------------------------------------------------------
-- File   : micom_7seg_2_vhdl_top.vhd
-- Date   : 2007-11-19
-- Family : Cyclone
-- Device : EP1C3T144C8
--
-- Designed by TOYO-LINX Co.,Ltd. / yKikuchi
-----------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity micom_7seg_2_vhdl_top is
	port(
		DATA	:	in std_logic;
		SCLK	:	in std_logic;
		CS		:	in std_logic;
		LED1A	:	out std_logic;
		LED1B	:	out std_logic;
		LED1C	:	out std_logic;
		LED1D	:	out std_logic;
		LED1E	:	out std_logic;
		LED1F	:	out std_logic;
		LED1G	:	out std_logic;
		LED1DP	:	out std_logic;
		LED2A	:	out std_logic;
		LED2B	:	out std_logic;
		LED2C	:	out std_logic;
		LED2D	:	out std_logic;
		LED2E	:	out std_logic;
		LED2F	:	out std_logic;
		LED2G	:	out std_logic;
		LED2DP	:	out std_logic
	);
end micom_7seg_2_vhdl_top;

architecture RTL of micom_7seg_2_vhdl_top is

	signal led1			:	std_logic_vector(7 downto 0);
	signal led2			:	std_logic_vector(7 downto 0);
	signal counter		:	std_logic_vector(3 downto 0);
	signal shift_reg	:	std_logic_vector(15 downto 0);

begin
	process(SCLK,CS)
	begin
		if(CS='0') then
			counter <= "0000";
		else
			if(SCLK'event and SCLK='1') then
				shift_reg(0)  <= shift_reg(1);
				shift_reg(1)  <= shift_reg(2);
				shift_reg(2)  <= shift_reg(3);
				shift_reg(3)  <= shift_reg(4);
				shift_reg(4)  <= shift_reg(5);
				shift_reg(5)  <= shift_reg(6);
				shift_reg(6)  <= shift_reg(7);
				shift_reg(7)  <= shift_reg(8);
				shift_reg(8)  <= shift_reg(9);
				shift_reg(9)  <= shift_reg(10);
				shift_reg(10) <= shift_reg(11);
				shift_reg(11) <= shift_reg(12);
				shift_reg(12) <= shift_reg(13);
				shift_reg(13) <= shift_reg(14);
				shift_reg(14) <= shift_reg(15);
				shift_reg(15) <= DATA;
				
				counter <= counter + 1;
			end if;

			if(SCLK'event and SCLK='0') then
				if(counter=0) then
					led2 <= shift_reg(15 downto 8);
					led1 <= shift_reg(7 downto 0);
				end if;
			end if;
		end if;
	end process;

	LED1A  <= led1(0);
	LED1B  <= led1(1);
	LED1C  <= led1(2);
	LED1D  <= led1(3);
	LED1E  <= led1(4);
	LED1F  <= led1(5);
	LED1G  <= led1(6);
	LED1DP <= led1(7);
	LED2A  <= led2(0);
	LED2B  <= led2(1);
	LED2C  <= led2(2);
	LED2D  <= led2(3);
	LED2E  <= led2(4);
	LED2F  <= led2(5);
	LED2G  <= led2(6);
	LED2DP <= led2(7);

end RTL;
