-----------------------------------------------------------
-- FPGA Training Board(B6101)
-- Select AND OR Circuit (4)
-----------------------------------------------------------
-- File   : select_and or_4_vhdl_top.vhd
-- Date   : 2009-06-08
-- Family : Cyclone
-- Device : EP1C3T144C8
--
-- Designed by TOYO-LINX Co.,Ltd. / yKikuchi
-----------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity select_and_or_4_vhdl_top is
	port(
		LED1	:	out std_logic;
		SW5		:	in std_logic;
		SW6		:	in std_logic;
		SW7		:	in std_logic
	);
end select_and_or_4_vhdl_top;

architecture RTL of select_and_or_4_vhdl_top is

	signal A	:	std_logic;
	signal B	:	std_logic;
	signal S	:	std_logic;
	signal Y	:	std_logic;

begin

	A <= not SW5;
	B <= not SW6;
	S <= not SW7;

	process(A,B,S)
	begin
		if(S='0') then
			Y <= A and B;
		else
			Y <= A or B;
		end if;
	end process;
	
	LED1 <= Y;
	
end RTL;
