-----------------------------------------------------------
-- FPGA Training Board(B6101)
-- Shift Register Circuit
-----------------------------------------------------------
-- File   : shift_reg_vhdl_top.vhd
-- Date   : 2009-06-05
-- Family : Cyclone
-- Device : EP1C3T144C8
--
-- Designed by TOYO-LINX Co.,Ltd. / yKikuchi
-----------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity shift_reg_vhdl_top is
	port(
		CLK		:	in std_logic;
		SW5		:	in std_logic;
		LED1	:	out std_logic;
		LED2	:	out std_logic;
		LED3	:	out std_logic;
		LED4	:	out std_logic;
		LED5	:	out std_logic;
		LED6	:	out std_logic;
		LED7	:	out std_logic;
		LED8	:	out std_logic
	);
end shift_reg_vhdl_top;

architecture RTL of shift_reg_vhdl_top is

	signal D		:	std_logic;
	signal Q		:	std_logic_vector(7 downto 0);
	signal div_cnt	:	std_logic_vector(31 downto 0);
	signal div_clk	:	std_logic;

begin
	
	process(CLK)
	begin
		if(CLK'event and CLK='1') then
			div_cnt <= div_cnt + 1;
		end if;
	end process;
	div_clk <= div_cnt(20);

	D <= not SW5;
	
	process(div_clk)
	begin
		if(div_clk'event and div_clk='1') then
			Q(7) <= Q(6);
			Q(6) <= Q(5);
			Q(5) <= Q(4);
			Q(4) <= Q(3);
			Q(3) <= Q(2);
			Q(2) <= Q(1);
			Q(1) <= Q(0);
			Q(0) <= D;
		end if;
	end process;

	LED1 <= Q(0);
	LED2 <= Q(1);
	LED3 <= Q(2);
	LED4 <= Q(3);
	LED5 <= Q(4);
	LED6 <= Q(5);
	LED7 <= Q(6);
	LED8 <= Q(7);
	
end RTL;
