/***********************************************************************/
/*                                                                     */
/*  FILE        :prog01_7seg.c                                         */
/*  DATE        :Tue, Nov 13, 2007                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :H8/3687                                               */
/*                                                                     */
/*  This file is programed by TOYO-LINX Co.,Ltd. / yKikuchi            */
/*                                                                     */
/***********************************************************************/

/************************************************************************
	CN[ht@C
************************************************************************/
#include	<machine.h>		// H8L̖߂g
#include	"iodefine.h"	// I/Õx`

/************************************************************************
	萔GA̒`(ROM)
************************************************************************/
//\f[^
const unsigned char SegLedData[][2] = {
	{0x01,0x00},{0x02,0x00},{0x04,0x00},{0x08,0x00},	// 0, 1, 2, 3
	{0x10,0x00},{0x20,0x00},{0x01,0x00},{0x00,0x01},	// 4, 5, 6, 7
	{0x00,0x02},{0x00,0x04},{0x00,0x08},{0x00,0x10},	// 8, 9,10,11
	{0x00,0x20},{0x00,0x01},{0x00,0x02},{0x00,0x04},	//12,13,14,15
	{0x00,0x08},{0x08,0x00},{0x10,0x00},{0x40,0x00},	//16,17,18,19
	{0x00,0x40},{0x00,0x02},{0x00,0x01},{0x01,0x00},	//20,21,22,23
	{0x20,0x00},{0x40,0x00},{0x00,0x40},{0x00,0x04},	//24,25,26,27
	{0x00,0x08},{0x08,0x00},{0x10,0x00},{0x20,0x00}		//28,29,30,31
};

/************************************************************************
	O[oϐ̒`ƃCjVCY(RAM)
************************************************************************/
// LED\Ɋ֌Wϐ ------------------------------------------------
unsigned long	SegLedBuf[2];	//\obt@

/************************************************************************
	֐̒`
************************************************************************/
void		init_io(void);
void		main(void);
void		set_7segLED_cont(void);
void		wait(void);

/************************************************************************
	CvO
************************************************************************/
void main(void)
{
	unsigned char i;
	
	init_io();	// I/O|[gCjVCY
	
	while(1){
		for (i=0; i<32; i++){
			SegLedBuf[0] = SegLedData[i][0];
			SegLedBuf[1] = SegLedData[i][1];
			set_7segLED_cont();
			wait();
		}
	}	
}

/************************************************************************
	7ZOgLEDRg[ɕ\f[^Zbg
************************************************************************/
void set_7segLED_cont(void)
{
	unsigned char a;

	a = 0x00;	//AhX

	IO.PDR3.BYTE	=	a | (IO.PDR3.BYTE & 0xc0);	//AhXZbg
	IO.PDR3.BIT.B6	=	0;							//-CS=Low
	IO.PDR6.BYTE	=	SegLedBuf[0];				//f[^Zbg
	IO.PDR3.BIT.B7	=	0;							//-WR=Low
	IO.PDR3.BIT.B7	=	1;							//-WR=High
	IO.PDR3.BIT.B6	=	1;							//-CS=High

	a++;

	IO.PDR3.BYTE	=	a | (IO.PDR3.BYTE & 0xc0);	//AhXZbg
	IO.PDR3.BIT.B6	=	0;							//-CS=Low
	IO.PDR6.BYTE	=	SegLedBuf[1];				//f[^Zbg
	IO.PDR3.BIT.B7	=	0;							//-WR=Low
	IO.PDR3.BIT.B7	=	1;							//-WR=High
	IO.PDR3.BIT.B6	=	1;							//-CS=High

}

/************************************************************************
	I/O|[g CjVCY
************************************************************************/
void init_io(void)
{
	IO.PCR3			=	0xff;	//|[g3,P30-37o
	IO.PDR3.BYTE	=	0xc0;

	IO.PMR5.BYTE	=	0x00;	//|[g5,ėpo̓|[g
	IO.PUCR5.BYTE	=	0x00;	//|[g5,vAbvIt
	IO.PCR5			=	0x80;	//|[g5,P50-56,P57o
	IO.PDR5.BYTE	=	0x00;

	IO.PCR6			=	0xff;	//|[g6,P60-67o
	IO.PDR6.BYTE	=	0x00;
}

/************************************************************************
	EFCg
************************************************************************/
void wait(void)
{
	unsigned long i;

	for (i=0;i<400000;i++){}
}
